#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include "world.h"


int main(int argc, char **argv)
{
	int changes;
	int i;
	int num_states;
	struct instruction *is;

	if (argc != 3 || (changes = atoi(argv[2])) <= 0) {
		fprintf(stderr, "usage: %s ant changes\n", argv[0]);
		exit(1);
	}

	{
		struct timeval tv;
		long seed;
		if (gettimeofday(&tv, NULL) == 0) {
			seed = tv.tv_sec + tv.tv_usec;
		} else {
			seed = time(NULL);
		}
		fprintf(stderr, "  random seed: %ld\n", seed);
		srand(seed);
	}

	is = read_program(argv[1]);
	for (num_states = 0; is[num_states].code != 0; num_states++)
		;
	fprintf(stderr, "ant %s has %d states.\n", argv[1], num_states);

	for (i = 0; i < changes; i++) {
		int j = rand() % num_states;
		random_instruction(&is[j], j, num_states);
	}

	print_program(is, stdout);
	return 0;

}
