#include "rng.h"



static unsigned int seed;


void rng_init(void)
{
	seed = 12345;
#ifndef FAST_RNG
	(void) randomint(16384);
	(void) randomint(16384);
	(void) randomint(16384);
#endif
}

#ifdef FAST_RNG
unsigned int randomint(unsigned int mask, unsigned int n)
{
	unsigned int r, s;
	s = seed;
	do {
		s = s * 22695477 + 1;
		r = (s >> 16) & mask;
	} while (r >= n);
	seed = s;
	return r;
}

unsigned int rng_mask(unsigned int n)
{
	n = n - 1;
	n = n | (n >> 1);
	n = n | (n >> 2);
	n = n | (n >> 4);
	n = n | (n >> 8);
	n = n | (n >>16);
	return n;
}

#else
unsigned int randomint(unsigned int n)
{
	unsigned int r;
	seed = seed * 22695477 + 1;
	r = (seed >> 16) & 16383;
	return (r % n);
}
#endif


#ifdef STANDALONE_TEST

#include <stdio.h>

int main(int argc, char **argv)
{
	int i;
	rng_init();
	for (i = 0; i < 100; i++)
		printf("%d\n", randomint(16384));
	return 0;
}


#endif /* STANDALONE_TEST */
